/* Include generic scientist behavior */
{ include("generic_scientist.asl") } 

/* Initial beliefs */
//percentage_rational(10).		// Percentage of rational cheaters
//max_review_distance(3).		// Maximum reviewing distance (used by the rational cheater strategy)
type(sc).						// Type of scientist (sc -> correct; r_sc -> rational cheater)

/* Plans */
// Set-up plan
+!init : avg_quality_beta(AvgQA,AvgQB) & max_value(MaxValue) &
	     author_skill_beta(AuthSkillA,AuthSkillB) & percentage_rational(PtgeRat)		 
   <- +author_skill(tools.beta(AuthSkillA,AuthSkillB)/2 + 0.5);
	  +reviewer_skill(1);
	  +author_avg_quality(math.min(math.floor(tools.beta(AvgQA,AvgQB) * MaxValue) + 1, MaxValue));
	  if (tools.random(nextDouble) < PtgeRat/100)
	  {
	    +rational;
		-+type(r_sc)
	  }
	  !generic_init. 

// Correct reviewing strategy
+?review(_, IValue, _, _, Review) : not rational 
   <-  Review = IValue.

// Rational cheating reviewing strategy
+?review(_, IValue, AcceptValue, _, Review) : rational & author_avg_quality(AvgQ) &
			                                  reviews_x_paper(RxP) & max_review_distance(Rd)
   <- if (IValue < AvgQ)
      {  
        Review = IValue;
	  } else {
        Review  = math.max(math.min(math.ceil((RxP*AcceptValue - (RxP-1)*IValue) - 1), IValue), IValue - Rd);
	  }.

